<html>
<head>
<title>OgreRadixSort.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRadixSort.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRadixSort_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RadixSort_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RadixSort_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 
<a name="l00087"></a>00087     <span class="keyword">template</span> &lt;<span class="keyword">class</span> TContainer, <span class="keyword">class</span> TContainerValueType, <span class="keyword">typename</span> TCompValueType&gt;
<a name="l00088"></a><a class="code" href="classOgre_1_1RadixSort.html">00088</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard...">RadixSort</a>
<a name="l00089"></a>00089     {
<a name="l00090"></a>00090     <span class="keyword">public</span>:
<a name="l00091"></a><a class="code" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">00091</a>         <span class="keyword">typedef</span> <span class="keyword">typename</span> TContainer::iterator <a class="code" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a>;
<a name="l00092"></a>00092     <span class="keyword">protected</span>:
<a name="l00095"></a><a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668">00095</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[4][256];
<a name="l00097"></a><a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64">00097</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[256];
<a name="l00099"></a><a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd">00099</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373">00101</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a>;
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html">00103</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>
<a name="l00104"></a>00104         {
<a name="l00105"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a6f46a958afebbd47ff723551f9893d83">00105</a>             TCompValueType <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a6f46a958afebbd47ff723551f9893d83">key</a>;
<a name="l00106"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#ae2f0a6d95f201f252c0c555e606268a8">00106</a>             <a class="code" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a> <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#ae2f0a6d95f201f252c0c555e606268a8">iter</a>;
<a name="l00107"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a2e33f6562eeda7b1d7a6a82492423c03">00107</a>             <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a2e33f6562eeda7b1d7a6a82492423c03">SortEntry</a>() {}
<a name="l00108"></a><a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a14793930d53046b5ba9bd53f8cb9084a">00108</a>             <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a2e33f6562eeda7b1d7a6a82492423c03">SortEntry</a>(TCompValueType k, <a class="code" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a> it)
<a name="l00109"></a>00109                 : <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#a6f46a958afebbd47ff723551f9893d83">key</a>(k), <a class="code" href="structOgre_1_1RadixSort_1_1SortEntry.html#ae2f0a6d95f201f252c0c555e606268a8">iter</a>(it) {}
<a name="l00110"></a>00110 
<a name="l00111"></a>00111         };
<a name="l00113"></a><a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">00113</a>         <span class="keyword">typedef</span> std::vector&lt;SortEntry, STLAllocator&lt;SortEntry, GeneralAllocPolicy&gt; &gt; <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a>; 
<a name="l00114"></a><a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">00114</a>         <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a> <a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">00115</a>         <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a> <a class="code" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">mSortArea2</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">00116</a>         <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a>* <a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">00117</a>         <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a>* <a class="code" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">00118</a>         TContainer <a class="code" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>; <span class="comment">// initial copy</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">00121</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">sortPass</a>(<span class="keywordtype">int</span> byteIndex)
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123             <span class="comment">// Calculate offsets</span>
<a name="l00124"></a>00124             <span class="comment">// Basically this just leaves gaps for duplicate entries to fill</span>
<a name="l00125"></a>00125             <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = 0;
<a name="l00126"></a>00126             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 256; ++i)
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128                 <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i-1];
<a name="l00129"></a>00129             }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131             <span class="comment">// Sort pass</span>
<a name="l00132"></a>00132             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00133"></a>00133             {
<a name="l00134"></a>00134                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a>)[i].key);
<a name="l00135"></a>00135                 (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         }
<a name="l00139"></a>00139         <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00140"></a><a class="code" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">00140</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a>(<span class="keywordtype">int</span> byteIndex, T val)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142             <span class="comment">// default is to do normal pass</span>
<a name="l00143"></a>00143             <a class="code" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">sortPass</a>(byteIndex);
<a name="l00144"></a>00144         }
<a name="l00145"></a>00145         
<a name="l00146"></a>00146         <span class="comment">// special case signed int</span>
<a name="l00147"></a><a class="code" href="classOgre_1_1RadixSort.html#a9d5c1b55a50cded48d3ccbe38182766e">00147</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a>(<span class="keywordtype">int</span> byteIndex, <span class="keywordtype">int</span> val)
<a name="l00148"></a>00148         {
<a name="l00149"></a>00149             <span class="keywordtype">int</span> numNeg = 0;
<a name="l00150"></a>00150             <span class="comment">// all negative values are in entries 128+ in most significant byte</span>
<a name="l00151"></a>00151             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 128; i &lt; 256; ++i)
<a name="l00152"></a>00152             {
<a name="l00153"></a>00153                 numNeg += <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i];
<a name="l00154"></a>00154             }
<a name="l00155"></a>00155             <span class="comment">// Calculate offsets - positive ones start at the number of negatives</span>
<a name="l00156"></a>00156             <span class="comment">// do positive numbers</span>
<a name="l00157"></a>00157             <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = numNeg;
<a name="l00158"></a>00158             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 128; ++i)
<a name="l00159"></a>00159             {
<a name="l00160"></a>00160                 <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i-1];
<a name="l00161"></a>00161             }
<a name="l00162"></a>00162             <span class="comment">// Do negative numbers (must start at zero)</span>
<a name="l00163"></a>00163             <span class="comment">// No need to invert ordering, already correct (-1 is highest number)</span>
<a name="l00164"></a>00164             <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[128] = 0;
<a name="l00165"></a>00165             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 129; i &lt; 256; ++i)
<a name="l00166"></a>00166             {
<a name="l00167"></a>00167                 <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i-1];
<a name="l00168"></a>00168             }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170             <span class="comment">// Sort pass</span>
<a name="l00171"></a>00171             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00172"></a>00172             {
<a name="l00173"></a>00173                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a>)[i].key);
<a name="l00174"></a>00174                 (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00175"></a>00175             }
<a name="l00176"></a>00176         }
<a name="l00177"></a>00177         
<a name="l00178"></a>00178 
<a name="l00179"></a>00179         <span class="comment">// special case float</span>
<a name="l00180"></a><a class="code" href="classOgre_1_1RadixSort.html#a985875ef2e1f317eea143cac7b7dc529">00180</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a>(<span class="keywordtype">int</span> byteIndex, <span class="keywordtype">float</span> val)
<a name="l00181"></a>00181         {
<a name="l00182"></a>00182             <span class="comment">// floats need to be special cased since negative numbers will come</span>
<a name="l00183"></a>00183             <span class="comment">// after positives (high bit = sign) and will be in reverse order</span>
<a name="l00184"></a>00184             <span class="comment">// (no ones-complement of the +ve value)</span>
<a name="l00185"></a>00185             <span class="keywordtype">int</span> numNeg = 0;
<a name="l00186"></a>00186             <span class="comment">// all negative values are in entries 128+ in most significant byte</span>
<a name="l00187"></a>00187             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 128; i &lt; 256; ++i)
<a name="l00188"></a>00188             {
<a name="l00189"></a>00189                 numNeg += <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i];
<a name="l00190"></a>00190             }
<a name="l00191"></a>00191             <span class="comment">// Calculate offsets - positive ones start at the number of negatives</span>
<a name="l00192"></a>00192             <span class="comment">// do positive numbers normally</span>
<a name="l00193"></a>00193             <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[0] = numNeg;
<a name="l00194"></a>00194             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 1; i &lt; 128; ++i)
<a name="l00195"></a>00195             {
<a name="l00196"></a>00196                 <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i-1] + <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i-1];
<a name="l00197"></a>00197             }
<a name="l00198"></a>00198             <span class="comment">// Do negative numbers (must start at zero)</span>
<a name="l00199"></a>00199             <span class="comment">// Also need to invert ordering</span>
<a name="l00200"></a>00200             <span class="comment">// In order to preserve the stability of the sort (essential since</span>
<a name="l00201"></a>00201             <span class="comment">// we rely on previous bytes already being sorted) we have to count</span>
<a name="l00202"></a>00202             <span class="comment">// backwards in our offsets from </span>
<a name="l00203"></a>00203             <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[255] = <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][255];
<a name="l00204"></a>00204             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 254; i &gt; 127; --i)
<a name="l00205"></a>00205             {
<a name="l00206"></a>00206                 <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i] = <a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[i+1] + <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[byteIndex][i];
<a name="l00207"></a>00207             }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209             <span class="comment">// Sort pass</span>
<a name="l00210"></a>00210             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a>; ++i)
<a name="l00211"></a>00211             {
<a name="l00212"></a>00212                 <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(byteIndex, (*<a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a>)[i].key);
<a name="l00213"></a>00213                 <span class="keywordflow">if</span> (byteVal &gt; 127)
<a name="l00214"></a>00214                 {
<a name="l00215"></a>00215                     <span class="comment">// -ve; pre-decrement since offsets set to count</span>
<a name="l00216"></a>00216                     (*mDest)[--<a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]] = (*mSrc)[i];
<a name="l00217"></a>00217                 }
<a name="l00218"></a>00218                 <span class="keywordflow">else</span>
<a name="l00219"></a>00219                 {
<a name="l00220"></a>00220                     <span class="comment">// +ve</span>
<a name="l00221"></a>00221                     (*mDest)[<a class="code" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64" title="Beta-pass offsets.">mOffsets</a>[byteVal]++] = (*mSrc)[i];
<a name="l00222"></a>00222                 }
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">00226</a>         <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(<span class="keywordtype">int</span> byteIndex, TCompValueType val)
<a name="l00227"></a>00227         {
<a name="l00228"></a>00228 <span class="preprocessor">#if OGRE_ENDIAN == OGRE_ENDIAN_LITTLE</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*)(&amp;val))[byteIndex];
<a name="l00230"></a>00230 <span class="preprocessor">#else</span>
<a name="l00231"></a>00231 <span class="preprocessor"></span>            <span class="keywordflow">return</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>*)(&amp;val))[<a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a> - byteIndex - 1];
<a name="l00232"></a>00232 <span class="preprocessor">#endif</span>
<a name="l00233"></a>00233 <span class="preprocessor"></span>        }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235     <span class="keyword">public</span>:
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classOgre_1_1RadixSort.html#a2c982200600a22b21906e3f43a0a962d">00237</a>         <a class="code" href="classOgre_1_1RadixSort.html#a2c982200600a22b21906e3f43a0a962d">RadixSort</a>() {}
<a name="l00238"></a><a class="code" href="classOgre_1_1RadixSort.html#a8f49cae4360e7c83b6ca7cf5714db761">00238</a>         <a class="code" href="classOgre_1_1RadixSort.html#a8f49cae4360e7c83b6ca7cf5714db761">~RadixSort</a>() {}
<a name="l00239"></a>00239 
<a name="l00245"></a>00245         <span class="keyword">template</span> &lt;<span class="keyword">class</span> TFunction&gt;
<a name="l00246"></a><a class="code" href="classOgre_1_1RadixSort.html#a4fc283b678dfda772eb6600436d97579">00246</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RadixSort.html#a4fc283b678dfda772eb6600436d97579" title="Main sort function.">sort</a>(TContainer&amp; container, TFunction func)
<a name="l00247"></a>00247         {
<a name="l00248"></a>00248             <span class="keywordflow">if</span> (container.empty())
<a name="l00249"></a>00249                 <span class="keywordflow">return</span>;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251             <span class="comment">// Set up the sort areas</span>
<a name="l00252"></a>00252             <a class="code" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd" title="Sort area size.">mSortSize</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(container.size());
<a name="l00253"></a>00253             <a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a>.resize(container.size());
<a name="l00254"></a>00254             <a class="code" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">mSortArea2</a>.resize(container.size());
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <span class="comment">// Copy data now (we need constant iterators for sorting)</span>
<a name="l00257"></a>00257             <a class="code" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a> = container;
<a name="l00258"></a>00258 
<a name="l00259"></a>00259             <a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a> = <span class="keyword">sizeof</span>(TCompValueType);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261             <span class="comment">// Counter pass</span>
<a name="l00262"></a>00262             <span class="comment">// Initialise the counts</span>
<a name="l00263"></a>00263             <span class="keywordtype">int</span> p;
<a name="l00264"></a>00264             <span class="keywordflow">for</span> (p = 0; p &lt; <a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a>; ++p)
<a name="l00265"></a>00265                 memset(<a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[p], 0, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>) * 256);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             <span class="comment">// Perform alpha pass to count</span>
<a name="l00268"></a>00268             <a class="code" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a> i = <a class="code" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>.begin();
<a name="l00269"></a>00269             TCompValueType prevValue = func.operator()(*i); 
<a name="l00270"></a>00270             <span class="keywordtype">bool</span> needsSorting = <span class="keyword">false</span>;
<a name="l00271"></a>00271             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> u = 0; i != <a class="code" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a>.end(); ++i, ++u)
<a name="l00272"></a>00272             {
<a name="l00273"></a>00273                 <span class="comment">// get sort value</span>
<a name="l00274"></a>00274                 TCompValueType val = func.operator()(*i);
<a name="l00275"></a>00275                 <span class="comment">// cheap check to see if needs sorting (temporal coherence)</span>
<a name="l00276"></a>00276                 <span class="keywordflow">if</span> (!needsSorting &amp;&amp; val &lt; prevValue)
<a name="l00277"></a>00277                     needsSorting = <span class="keyword">true</span>;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279                 <span class="comment">// Create a sort entry</span>
<a name="l00280"></a>00280                 <a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a>[u].key = val;
<a name="l00281"></a>00281                 <a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a>[u].iter = i;
<a name="l00282"></a>00282 
<a name="l00283"></a>00283                 <span class="comment">// increase counters</span>
<a name="l00284"></a>00284                 <span class="keywordflow">for</span> (p = 0; p &lt; <a class="code" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373" title="Number of passes for this type.">mNumPasses</a>; ++p)
<a name="l00285"></a>00285                 {
<a name="l00286"></a>00286                     <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> byteVal = <a class="code" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a>(p, val);
<a name="l00287"></a>00287                     <a class="code" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668" title="Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value...">mCounters</a>[p][byteVal]++;
<a name="l00288"></a>00288                 }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290                 prevValue = val;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292             }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294             <span class="comment">// early exit if already sorted</span>
<a name="l00295"></a>00295             <span class="keywordflow">if</span> (!needsSorting)
<a name="l00296"></a>00296                 <span class="keywordflow">return</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299             <span class="comment">// Sort passes</span>
<a name="l00300"></a>00300             <a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a> = &amp;<a class="code" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a>;
<a name="l00301"></a>00301             <a class="code" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a> = &amp;<a class="code" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">mSortArea2</a>;
<a name="l00302"></a>00302 
<a name="l00303"></a>00303             <span class="keywordflow">for</span> (p = 0; p &lt; mNumPasses - 1; ++p)
<a name="l00304"></a>00304             {
<a name="l00305"></a>00305                 <a class="code" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">sortPass</a>(p);
<a name="l00306"></a>00306                 <span class="comment">// flip src/dst</span>
<a name="l00307"></a>00307                 <a class="code" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e" title="Temp sort storage.">SortVector</a>* tmp = <a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a>;
<a name="l00308"></a>00308                 <a class="code" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a> = <a class="code" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a>;
<a name="l00309"></a>00309                 <a class="code" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a> = tmp;
<a name="l00310"></a>00310             }
<a name="l00311"></a>00311             <span class="comment">// Final pass may differ, make polymorphic</span>
<a name="l00312"></a>00312             <a class="code" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a>(p, prevValue);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314             <span class="comment">// Copy everything back</span>
<a name="l00315"></a>00315             <span class="keywordtype">int</span> c = 0;
<a name="l00316"></a>00316             <span class="keywordflow">for</span> (i = container.begin(); 
<a name="l00317"></a>00317                 i != container.end(); ++i, ++c)
<a name="l00318"></a>00318             {
<a name="l00319"></a>00319                 *i = *((*mDest)[c].iter);
<a name="l00320"></a>00320             }
<a name="l00321"></a>00321         }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323     };
<a name="l00324"></a>00324 
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 <span class="preprocessor">#endif</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
